Loading...
Searching...
No Matches
dolfin::NonlinearVariationalProblem Class Reference

`#include <NonlinearVariationalProblem.h>`

Inheritance diagram for dolfin::NonlinearVariationalProblem:
[legend]
Collaboration diagram for dolfin::NonlinearVariationalProblem:
[legend]

## Public Member Functions

| NonlinearVariationalProblem (std::shared_ptr< const Form > F, std::shared_ptr< Function > u, std::vector< std::shared_ptr< const DirichletBC > > bcs, std::shared_ptr< const Form > J=nullptr)
void | set_bounds (const Function &lb_func, const Function &ub_func)
| Set the bounds for bound constrained solver.
void | set_bounds (std::shared_ptr< const GenericVector > lb, std::shared_ptr< const GenericVector > ub)
| Set the bounds for bound constrained solver.
std::shared_ptr< const Form > | residual_form () const
| Return residual form.
std::shared_ptr< const Form > | jacobian_form () const
| Return Jacobian form.
std::shared_ptr< Function > | solution ()
| Return solution variable.
std::shared_ptr< const Function > | solution () const
| Return solution variable (const version).
std::vector< std::shared_ptr< const DirichletBC > > | bcs () const
| Return boundary conditions.
std::shared_ptr< const FunctionSpace > | trial_space () const
| Return trial space.
std::shared_ptr< const FunctionSpace > | test_space () const
| Return test space.
std::shared_ptr< const GenericVector > | lower_bound () const
| Return lower bound.
std::shared_ptr< const GenericVector > | upper_bound () const
| Return upper bound.
bool | has_jacobian () const
| Check whether Jacobian has been defined.
bool | has_lower_bound () const
| Check whether lower bound has been defined.
bool | has_upper_bound () const
| Check whether upper bound have has defined.
Public Member Functions inherited from dolfin::Hierarchical< NonlinearVariationalProblem >
| Hierarchical (NonlinearVariationalProblem &self)
| Constructor.
virtual | ~Hierarchical ()
| Destructor.
std::size_t | depth () const
bool | has_parent () const
bool | has_child () const
NonlinearVariationalProblem & | parent ()
std::shared_ptr< NonlinearVariationalProblem > | parent_shared_ptr ()
NonlinearVariationalProblem & | child ()
std::shared_ptr< NonlinearVariationalProblem > | child_shared_ptr ()
NonlinearVariationalProblem & | root_node ()
std::shared_ptr< NonlinearVariationalProblem > | root_node_shared_ptr ()
NonlinearVariationalProblem & | leaf_node ()
std::shared_ptr< NonlinearVariationalProblem > | leaf_node_shared_ptr ()
void | set_parent (std::shared_ptr< NonlinearVariationalProblem > parent)
| Set parent.
void | clear_child ()
| Clear child.
void | set_child (std::shared_ptr< NonlinearVariationalProblem > child)
| Set child.
const Hierarchical & | operator= (const Hierarchical &hierarchical)
| Assignment operator.
void | _debug () const
| Function useful for debugging the hierarchy.

## Detailed Description

This class represents a nonlinear variational problem:

Find u in V such that

    F(u; v) = 0  for all v in V^,

where V is the trial space and V^ is the test space.

## Constructor & Destructor Documentation

## NonlinearVariationalProblem()

NonlinearVariationalProblem::NonlinearVariationalProblem | ( | std::shared_ptr< const Form > | F,
|  | std::shared_ptr< Function > | u,
|  | std::vector< std::shared_ptr< const DirichletBC > > | bcs,
|  | std::shared_ptr< const Form > | J = nullptr )

Create nonlinear variational problem, shared pointer version. The Jacobian form is specified which allows the use of a nonlinear solver that relies on the Jacobian (using Newton's method).

The documentation for this class was generated from the following files:

- /build/dolfin-wwk1CC/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/fem/NonlinearVariationalProblem.h
- /build/dolfin-wwk1CC/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/fem/NonlinearVariationalProblem.cpp